#include "HFrameLabel.h"

HFrameLabel::HFrameLabel (QWidget*    parent,
                          Qt::WFlags  f)
   : QFrame(parent, f)
{
   defaultPalette = palette();

   setFrameShape(QFrame::StyledPanel);
   setFrameShadow(QFrame::Plain);
   setAutoFillBackground(true);

   hbox = new QHBoxLayout(this);
   hbox->setMargin(2);
   setLayout(hbox);

   label = new QLabel(this);
   hbox->addWidget(label);
   label->setAlignment(Qt::AlignCenter);
   label->show();
}

HFrameLabel::HFrameLabel (const QString&  text,
                          QWidget*        parent,
                          Qt::WFlags      f)
   : QFrame(parent, f)
{
   defaultPalette = palette();

   setFrameShape(QFrame::StyledPanel);
   setFrameShadow(QFrame::Plain);
   setAutoFillBackground(true);

   hbox = new QHBoxLayout(this);
   hbox->setMargin(2);
   setLayout(hbox);

   label = new QLabel(text, this);
   hbox->addWidget(label);
   label->setAlignment(Qt::AlignCenter);
   label->show();
}

void HFrameLabel::setText (const QString&   text)
{
   label->setText(text);
   setFrameShape(text.isEmpty() ? QFrame::NoFrame : QFrame::StyledPanel);
   QFrame::setPalette(text.isEmpty() ? defaultPalette : activePalette);
}

void HFrameLabel::setPalette (const QPalette&  palette)
{
   activePalette = palette;
   if (!label->text().isEmpty()) {
      QFrame::setPalette(palette);
   }
}
